import { jsx as f, jsxs as z } from "react/jsx-runtime";
import W, { useRef as y, useEffect as _, useCallback as G, useState as P, useMemo as J, useId as K, useReducer as Q, useLayoutEffect as $ } from "react";
import o from "clsx";
const L = "av-text-input", ge = "av-text-input-simple", Y = "av-text-input-wrapper", I = "av-text-input-helper-text";
function Z() {
  const e = y(!1);
  return _(() => (e.current = !0, () => {
    e.current = !1;
  }), []), G(() => e.current, []);
}
const B = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function ee(e) {
  const r = Z(), t = y(0), n = y(null), [l, c] = P(B), a = J(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((u) => {
    const p = u[0];
    p && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && c(p.contentRect);
    }));
  }), [r]);
  return _(() => (n.current && (a == null || a.observe(n.current, e)), () => {
    a == null || a.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [a, e]), [n, l];
}
function te(e) {
  const r = K();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const D = "SET_ANNOUNCEMENT", w = "CLEAR_ANNOUNCEMENT", re = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, ne = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case D:
      return {
        ...e,
        announcement: r.payload
      };
    case w:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, le = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: w
  }), typeof e == "function" && e();
}, S = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: l
}) => {
  (t == null ? void 0 : t.current) !== null && clearTimeout(t.current), e !== null && l({
    type: D,
    payload: e
  }), r && (t.current = setTimeout(
    () => le({
      onAnnouncementClear: n,
      dispatch: l
    }),
    r
  ));
}, ae = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: l,
  onAnnouncementClear: c,
  dispatch: a
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(S, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: c,
    dispatch: a
  }) : S({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: l,
    onAnnouncementClear: c,
    dispatch: a
  });
};
function ce({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: l,
  clearAnnouncementDelay: c,
  onAnnouncementClear: a,
  visible: u,
  ...p
}) {
  const m = y(), x = y(), [s, g] = Q(ne, {
    announcement: null
  });
  let d = t;
  typeof d > "u" && (d = n ? re[n] : "assertive"), _(() => {
    ae({
      announcementTimeoutRef: m,
      announcementDelay: l,
      children: e,
      clearAnnouncementDelay: c,
      clearAnnouncementTimeoutRef: x,
      onAnnouncementClear: a,
      dispatch: g
    });
  }, [
    e,
    l,
    c,
    a
  ]);
  const i = o(r, {
    "sr-only": !u
  });
  return /* @__PURE__ */ f(
    "div",
    {
      "aria-live": d,
      ...n && { role: n },
      className: i,
      ...p,
      children: s.announcement
    }
  );
}
const oe = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
};
/*!
  @versini/ui-private v1.4.17
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.17",
    buildTime: "09/27/2024 11:55 AM EDT",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const se = ({
  mode: e
}) => o({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), ue = ({
  focusMode: e
}) => o("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), ie = ({
  noBorder: e,
  error: r
}) => o("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), pe = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n
}) => {
  if (r)
    return "";
  if (e)
    return o("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return o("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-lighter": n === "system",
      "text-copy-lighter dark:text-copy-dark": n === "alt-system"
    });
  if (t)
    return o("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": n === "system",
      "text-copy-lighter dark:text-copy-error-dark": n === "alt-system"
    });
}, de = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return o(
      I,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return o(I, "absolute px-2 font-medium", {
      "text-copy-lighter": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-lighter": t === "system",
      "text-copy-lighter dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return o(I, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": t === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": t === "alt-system"
    });
}, fe = ({
  className: e,
  inputClassName: r,
  raw: t,
  disabled: n,
  noBorder: l,
  error: c,
  spacing: a,
  mode: u,
  focusMode: p,
  size: m
}) => {
  const x = t ? e : o(
    "relative flex w-full flex-col justify-center",
    Y,
    e,
    oe(a)
  );
  let s = "";
  switch (m) {
    case "xs":
      s = "h-8";
      break;
    case "sm":
      s = "h-10";
      break;
    case "lg":
      s = "h-14";
      break;
    case "xl":
      s = "h-16";
      break;
    default:
      s = "h-12";
      break;
  }
  const g = t ? o(r) : o(
    L,
    r,
    s,
    "rounded-md text-base px-4",
    se({ mode: u }),
    ue({ focusMode: p }),
    ie({ noBorder: l, error: c }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": n
    }
  ), d = t ? void 0 : "sr-only", i = pe({
    disabled: n,
    raw: t,
    error: c,
    mode: u
  }), b = de({
    error: c,
    raw: t,
    mode: u,
    disabled: n
  });
  return {
    wrapper: x,
    input: g,
    accessibleLabel: d,
    visibleLabel: i,
    helperText: b,
    rightElement: t ? void 0 : "absolute right-3"
  };
}, ye = W.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: l = !1,
    className: c,
    inputClassName: a,
    mode: u = "system",
    focusMode: p = "system",
    disabled: m = !1,
    noBorder: x = !1,
    labelId: s,
    labelHidden: g = !1,
    type: d = "text",
    helperText: i = "",
    rightElement: b,
    spacing: C,
    size: E = "md",
    ...M
  }, U) => {
    const [j, T] = ee(), [F, O] = P(0), k = te({ id: e, prefix: `${L}-` }), X = `${r} error, ${i}`, A = y(null), v = y(null), V = {
      xs: { label: "-25px", helperText: "30px" },
      sm: { label: "-29px", helperText: "34px" },
      md: { label: "-33px", helperText: "38px" },
      lg: { label: "-15px", helperText: "22px" },
      xl: { label: "-19px", helperText: "25px" }
    }, h = fe({
      className: c,
      inputClassName: a,
      error: n,
      raw: l,
      focusMode: p,
      disabled: m,
      noBorder: x,
      spacing: C,
      mode: u,
      size: E
    });
    return $(() => {
      T && T.width && O(T.width + 18 + 10);
    }, [T]), $(() => {
      var R, N;
      const { label: q, helperText: H } = V[E];
      (R = A == null ? void 0 : A.current) == null || R.style.setProperty("--av-text-input-label", q), (N = v == null ? void 0 : v.current) == null || N.style.setProperty(
        "--av-text-input-helper-text",
        H
      );
    }, [E]), /* @__PURE__ */ z("div", { className: h.wrapper, children: [
      /* @__PURE__ */ f(
        "label",
        {
          htmlFor: k,
          id: s,
          className: h.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ f(
        "input",
        {
          ref: U,
          id: k,
          name: r,
          type: d,
          disabled: m,
          placeholder: l ? void 0 : " ",
          className: h.input,
          ...i && { "aria-describedby": `${k}-helper` },
          ...n && { "aria-invalid": "true" },
          ...b && !l && { style: { paddingRight: F } },
          ...M
        }
      ),
      !l && !g && /* @__PURE__ */ f(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: k,
          className: h.visibleLabel,
          children: t
        }
      ),
      i && /* @__PURE__ */ f(
        "div",
        {
          ref: v,
          id: `${k}-helper`,
          className: h.helperText,
          children: i
        }
      ),
      b && /* @__PURE__ */ f(
        "div",
        {
          ref: j,
          className: h.rightElement,
          children: b
        }
      ),
      n && i && /* @__PURE__ */ f(ce, { politeness: "polite", clearAnnouncementDelay: 500, children: X })
    ] });
  }
);
ye.displayName = "TextInput";
export {
  L as TEXT_INPUT_CLASSNAME,
  I as TEXT_INPUT_HELPER_TEXT_CLASSNAME,
  ge as TEXT_INPUT_SIMPLE_CLASSNAME,
  Y as TEXT_INPUT_WRAPPER_CLASSNAME,
  ye as TextInput,
  ce as j
};
